<template>
    <ComponentView name="own"
                    @increase="e => $di.$counterService.increase()"
                    info="* Will increase component's counter">
        <CountView title="Component's count"
                    :value="$di.$counterService.count" />
        <CountView title="Main count"
                    :value="$parent.$di.$counterService.count" />
    </ComponentView>
</template>


<script lang="ts">
import { Vue } from 'vue-property-decorator';
import { Component } from '@/lib/vue-di/di.decorator';
import { CounterService } from '@/test-app/counter.service';
import { Observer } from 'mobx-vue';
import ComponentView from '@/test-app/components/component-view.vue';
import CountView from '@/test-app/components/count-view.vue';


@Observer
@Component({
    dependencies: {
        $counterService: CounterService
    },
    components: {
        ComponentView,
        CountView
    }
})
export default class ComponentWithOwnDependencies extends Vue {}
</script>
